// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIColumn;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a UIComponent that represents a single column of data within a
  parent UISheet component.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ColumnTagDeclaration}.
 */
public class UIColumn
    extends AbstractUIColumn implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Column";

  private org.apache.myfaces.tobago.context.Markup markup;
  private org.apache.myfaces.tobago.layout.Measure paddingTop;
  private java.lang.String width;
  private java.lang.Boolean sortable;
  private java.lang.String align;
  private java.lang.String label;
  private org.apache.myfaces.tobago.layout.Measure borderBottom;
  private org.apache.myfaces.tobago.layout.Measure borderLeft;
  private java.lang.String tip;
  private org.apache.myfaces.tobago.layout.Measure paddingLeft;
  private org.apache.myfaces.tobago.layout.Measure paddingRight;
  private org.apache.myfaces.tobago.layout.Measure borderTop;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Boolean overflowX;
  private java.lang.Boolean resizable;
  private java.lang.Boolean overflowY;
  private org.apache.myfaces.tobago.layout.Measure borderRight;
  private org.apache.myfaces.tobago.layout.Measure paddingBottom;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingTop() {
    if (paddingTop != null) {
      return paddingTop;
    }
    ValueExpression ve = getValueExpression("paddingTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingTop(getFacesContext(), this);
  }

  public void setPaddingTop(org.apache.myfaces.tobago.layout.Measure paddingTop) {
    this.paddingTop = paddingTop;
  }

  /**
  The layout token for this column.
   Allowd layout tokens ('*', '&lt;x>*', '&lt;x>px' or '&lt;x>%').
   Where '*' is equvalent to '1*'.

  */
  public java.lang.String getWidth() {
    if (width != null) {
      return width;
    }
    ValueExpression ve = getValueExpression("width");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setWidth(java.lang.String width) {
    this.width = width;
  }

  /**
  Flag indicating whether or not this column is sortable.
   To make a column sortable the data of the sheet must be one of
   <code>java.util.List</code> or <code>Object[]</code>.
  <br />Default: <code>false</code>
  */
  public boolean isSortable() {
    if (sortable != null) {
      return sortable;
    }
    ValueExpression ve = getValueExpression("sortable");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setSortable(boolean sortable) {
    this.sortable = sortable;
  }

  /**
  Alignment of this column.

  */
  public java.lang.String getAlign() {
    if (align != null) {
      return align;
    }
    ValueExpression ve = getValueExpression("align");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setAlign(java.lang.String align) {
    this.align = align;
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    if (label != null) {
      return label;
    }
    ValueExpression ve = getValueExpression("label");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLabel(java.lang.String label) {
    this.label = label;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderBottom() {
    if (borderBottom != null) {
      return borderBottom;
    }
    ValueExpression ve = getValueExpression("borderBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderBottom(getFacesContext(), this);
  }

  public void setBorderBottom(org.apache.myfaces.tobago.layout.Measure borderBottom) {
    this.borderBottom = borderBottom;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderLeft() {
    if (borderLeft != null) {
      return borderLeft;
    }
    ValueExpression ve = getValueExpression("borderLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderLeft(getFacesContext(), this);
  }

  public void setBorderLeft(org.apache.myfaces.tobago.layout.Measure borderLeft) {
    this.borderLeft = borderLeft;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingLeft() {
    if (paddingLeft != null) {
      return paddingLeft;
    }
    ValueExpression ve = getValueExpression("paddingLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingLeft(getFacesContext(), this);
  }

  public void setPaddingLeft(org.apache.myfaces.tobago.layout.Measure paddingLeft) {
    this.paddingLeft = paddingLeft;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingRight() {
    if (paddingRight != null) {
      return paddingRight;
    }
    ValueExpression ve = getValueExpression("paddingRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingRight(getFacesContext(), this);
  }

  public void setPaddingRight(org.apache.myfaces.tobago.layout.Measure paddingRight) {
    this.paddingRight = paddingRight;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderTop() {
    if (borderTop != null) {
      return borderTop;
    }
    ValueExpression ve = getValueExpression("borderTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderTop(getFacesContext(), this);
  }

  public void setBorderTop(org.apache.myfaces.tobago.layout.Measure borderTop) {
    this.borderTop = borderTop;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowX() {
    if (overflowX != null) {
      return overflowX;
    }
    ValueExpression ve = getValueExpression("overflowX");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setOverflowX(boolean overflowX) {
    this.overflowX = overflowX;
  }

  /**
  Flag indicating whether or not the width of this column in a sheet is resizable, by the user.
  <br />Default: <code>true</code>
  */
  public boolean isResizable() {
    if (resizable != null) {
      return resizable;
    }
    ValueExpression ve = getValueExpression("resizable");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setResizable(boolean resizable) {
    this.resizable = resizable;
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowY() {
    if (overflowY != null) {
      return overflowY;
    }
    ValueExpression ve = getValueExpression("overflowY");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setOverflowY(boolean overflowY) {
    this.overflowY = overflowY;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderRight() {
    if (borderRight != null) {
      return borderRight;
    }
    ValueExpression ve = getValueExpression("borderRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderRight(getFacesContext(), this);
  }

  public void setBorderRight(org.apache.myfaces.tobago.layout.Measure borderRight) {
    this.borderRight = borderRight;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingBottom() {
    if (paddingBottom != null) {
      return paddingBottom;
    }
    ValueExpression ve = getValueExpression("paddingBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingBottom(getFacesContext(), this);
  }

  public void setPaddingBottom(org.apache.myfaces.tobago.layout.Measure paddingBottom) {
    this.paddingBottom = paddingBottom;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    paddingTop = (org.apache.myfaces.tobago.layout.Measure) values[2];
    width = (java.lang.String) values[3];
    sortable = (java.lang.Boolean) values[4];
    align = (java.lang.String) values[5];
    label = (java.lang.String) values[6];
    borderBottom = (org.apache.myfaces.tobago.layout.Measure) values[7];
    borderLeft = (org.apache.myfaces.tobago.layout.Measure) values[8];
    tip = (java.lang.String) values[9];
    paddingLeft = (org.apache.myfaces.tobago.layout.Measure) values[10];
    paddingRight = (org.apache.myfaces.tobago.layout.Measure) values[11];
    borderTop = (org.apache.myfaces.tobago.layout.Measure) values[12];
    overflowX = (java.lang.Boolean) values[13];
    resizable = (java.lang.Boolean) values[14];
    overflowY = (java.lang.Boolean) values[15];
    borderRight = (org.apache.myfaces.tobago.layout.Measure) values[16];
    paddingBottom = (org.apache.myfaces.tobago.layout.Measure) values[17];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[18];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = paddingTop;
    values[3] = width;
    values[4] = sortable;
    values[5] = align;
    values[6] = label;
    values[7] = borderBottom;
    values[8] = borderLeft;
    values[9] = tip;
    values[10] = paddingLeft;
    values[11] = paddingRight;
    values[12] = borderTop;
    values[13] = overflowX;
    values[14] = resizable;
    values[15] = overflowY;
    values[16] = borderRight;
    values[17] = paddingBottom;
    currentMarkup = null;
    return values;
  }


}